package anywheresoftware.b4a.samples.bluetooth;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.bluetooth", "anywheresoftware.b4a.samples.bluetooth.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.bluetooth", "anywheresoftware.b4a.samples.bluetooth.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public static class _nameandmac{
public boolean IsInitialized;
public String Name;
public String Mac;
public void Initialize() {
IsInitialized = true;
Name = "";
Mac = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _admin = null;
public static anywheresoftware.b4a.objects.Serial _serial1 = null;
public static anywheresoftware.b4a.objects.Serial _serial2 = null;
public static anywheresoftware.b4a.objects.collections.List _founddevices = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnsearchfordevices = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnallowconnection = null;
public anywheresoftware.b4a.samples.bluetooth.chatactivity _chatactivity = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 30;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 31;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(1073741824);
if (_firsttime) { 
 BA.debugLineNum = 33;BA.debugLine="admin.Initialize(\"admin\")";
Debug.ShouldStop(1);
_admin.Initialize(processBA,"admin");
 BA.debugLineNum = 34;BA.debugLine="serial1.Initialize(\"serial1\")";
Debug.ShouldStop(2);
Debug.DebugWarningEngine.CheckInitialize(_serial1);_serial1.Initialize("serial1");
 BA.debugLineNum = 35;BA.debugLine="serial2.Initialize(\"serial2\")";
Debug.ShouldStop(4);
Debug.DebugWarningEngine.CheckInitialize(_serial2);_serial2.Initialize("serial2");
 };
 BA.debugLineNum = 37;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(16);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 38;BA.debugLine="End Sub";
Debug.ShouldStop(32);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 61;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 62;BA.debugLine="If UserClosed = True Then";
Debug.ShouldStop(536870912);
if (_userclosed==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 63;BA.debugLine="serial1.Disconnect";
Debug.ShouldStop(1073741824);
_serial1.Disconnect();
 };
 BA.debugLineNum = 65;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 40;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(128);
 BA.debugLineNum = 41;BA.debugLine="btnSearchForDevices.Enabled = False";
Debug.ShouldStop(256);
mostCurrent._btnsearchfordevices.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 42;BA.debugLine="btnAllowConnection.Enabled = False";
Debug.ShouldStop(512);
mostCurrent._btnallowconnection.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 44;BA.debugLine="If admin.IsEnabled = False Then";
Debug.ShouldStop(2048);
if (_admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 45;BA.debugLine="If admin.Enable = False Then";
Debug.ShouldStop(4096);
if (_admin.Enable()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 46;BA.debugLine="ToastMessageShow(\"Error enabling Bluetooth adapter.\", True)";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error enabling Bluetooth adapter.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 48;BA.debugLine="ToastMessageShow(\"Enabling Bluetooth adapter...\", False)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Enabling Bluetooth adapter...",anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 BA.debugLineNum = 52;BA.debugLine="Admin_StateChanged(admin.STATE_ON, 0)";
Debug.ShouldStop(524288);
_admin_statechanged(_admin.STATE_ON,(int)(0));
 };
 BA.debugLineNum = 54;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _admin_devicefound(String _name,String _macaddress) throws Exception{
		Debug.PushSubsStack("Admin_DeviceFound (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.samples.bluetooth.main._nameandmac _nm = null;
Debug.locals.put("Name", _name);
Debug.locals.put("MacAddress", _macaddress);
 BA.debugLineNum = 117;BA.debugLine="Sub Admin_DeviceFound (Name As String, MacAddress As String)";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 118;BA.debugLine="Log(Name & \":\" & MacAddress)";
Debug.ShouldStop(2097152);
anywheresoftware.b4a.keywords.Common.Log(_name+":"+_macaddress);
 BA.debugLineNum = 119;BA.debugLine="Dim nm As NameAndMac";
Debug.ShouldStop(4194304);
_nm = new anywheresoftware.b4a.samples.bluetooth.main._nameandmac();Debug.locals.put("nm", _nm);
 BA.debugLineNum = 120;BA.debugLine="nm.Name = Name";
Debug.ShouldStop(8388608);
_nm.Name = _name;Debug.locals.put("nm", _nm);
 BA.debugLineNum = 121;BA.debugLine="nm.Mac = MacAddress";
Debug.ShouldStop(16777216);
_nm.Mac = _macaddress;Debug.locals.put("nm", _nm);
 BA.debugLineNum = 122;BA.debugLine="foundDevices.Add(nm)";
Debug.ShouldStop(33554432);
_founddevices.Add((Object)(_nm));
 BA.debugLineNum = 123;BA.debugLine="ProgressDialogShow(\"Searching for devices (~ device found)...\".Replace(\"~\", foundDevices.Size))";
Debug.ShouldStop(67108864);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Searching for devices (~ device found)...".replace("~",BA.NumberToString(_founddevices.getSize())));
 BA.debugLineNum = 124;BA.debugLine="End Sub";
Debug.ShouldStop(134217728);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _admin_discoveryfinished() throws Exception{
		Debug.PushSubsStack("Admin_DiscoveryFinished (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.collections.List _l = null;
int _i = 0;
anywheresoftware.b4a.samples.bluetooth.main._nameandmac _nm = null;
 BA.debugLineNum = 76;BA.debugLine="Sub Admin_DiscoveryFinished";
Debug.ShouldStop(2048);
 BA.debugLineNum = 77;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(4096);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 78;BA.debugLine="If foundDevices.Size = 0 Then";
Debug.ShouldStop(8192);
if (_founddevices.getSize()==0) { 
 BA.debugLineNum = 79;BA.debugLine="ToastMessageShow(\"No device found.\", True)";
Debug.ShouldStop(16384);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("No device found.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 81;BA.debugLine="Dim l As List";
Debug.ShouldStop(65536);
_l = new anywheresoftware.b4a.objects.collections.List();Debug.locals.put("l", _l);
 BA.debugLineNum = 82;BA.debugLine="l.Initialize";
Debug.ShouldStop(131072);
_l.Initialize();
 BA.debugLineNum = 83;BA.debugLine="For i = 0 To foundDevices.Size - 1";
Debug.ShouldStop(262144);
{
final double step56 = 1;
final double limit56 = (int)(_founddevices.getSize()-1);
for (_i = (int)(0); (step56 > 0 && _i <= limit56) || (step56 < 0 && _i >= limit56); _i += step56) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 84;BA.debugLine="Dim nm As NameAndMac";
Debug.ShouldStop(524288);
_nm = new anywheresoftware.b4a.samples.bluetooth.main._nameandmac();Debug.locals.put("nm", _nm);
 BA.debugLineNum = 85;BA.debugLine="nm = foundDevices.Get(i)";
Debug.ShouldStop(1048576);
_nm = (anywheresoftware.b4a.samples.bluetooth.main._nameandmac)(_founddevices.Get(_i));Debug.locals.put("nm", _nm);
 BA.debugLineNum = 86;BA.debugLine="l.Add(nm.Name)";
Debug.ShouldStop(2097152);
_l.Add((Object)(_nm.Name));
 BA.debugLineNum = 87;BA.debugLine="If nm.Name.StartsWith(\"R\") Then    'Here i basically look for my device's name which starts with the letter \"R\"";
Debug.ShouldStop(4194304);
if (_nm.Name.startsWith("R")) { 
 BA.debugLineNum = 88;BA.debugLine="Log(\"Connecting.....\")";
Debug.ShouldStop(8388608);
anywheresoftware.b4a.keywords.Common.Log("Connecting.....");
 BA.debugLineNum = 89;BA.debugLine="serial1.ConnectInsecure(admin, nm.Mac, 1)       'Also try using ConnectInsecure, is a better way to connect since there are devices that have some issues when trying to connect with Connect, or Connect2 or Connect3";
Debug.ShouldStop(16777216);
_serial1.ConnectInsecure(processBA,_admin,_nm.Mac,(int)(1));
 BA.debugLineNum = 90;BA.debugLine="Exit";
Debug.ShouldStop(33554432);
if (true) break;
 };
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 95;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 96;BA.debugLine="If foundDevices.Size = 0 Then";
Debug.ShouldStop(-2147483648);
if (_founddevices.getSize()==0) { 
 BA.debugLineNum = 97;BA.debugLine="ToastMessageShow(\"No device found.\", True)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("No device found.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 99;BA.debugLine="Dim l As List";
Debug.ShouldStop(4);
_l = new anywheresoftware.b4a.objects.collections.List();Debug.locals.put("l", _l);
 BA.debugLineNum = 100;BA.debugLine="l.Initialize";
Debug.ShouldStop(8);
_l.Initialize();
 BA.debugLineNum = 101;BA.debugLine="For i = 0 To foundDevices.Size - 1";
Debug.ShouldStop(16);
{
final double step73 = 1;
final double limit73 = (int)(_founddevices.getSize()-1);
for (_i = (int)(0); (step73 > 0 && _i <= limit73) || (step73 < 0 && _i >= limit73); _i += step73) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 102;BA.debugLine="Dim nm As NameAndMac";
Debug.ShouldStop(32);
_nm = new anywheresoftware.b4a.samples.bluetooth.main._nameandmac();Debug.locals.put("nm", _nm);
 BA.debugLineNum = 103;BA.debugLine="nm = foundDevices.Get(i)";
Debug.ShouldStop(64);
_nm = (anywheresoftware.b4a.samples.bluetooth.main._nameandmac)(_founddevices.Get(_i));Debug.locals.put("nm", _nm);
 BA.debugLineNum = 104;BA.debugLine="l.Add(nm.Name)";
Debug.ShouldStop(128);
_l.Add((Object)(_nm.Name));
 BA.debugLineNum = 105;BA.debugLine="If nm.Name.StartsWith(\"H\") Then    'Here i basically look for my device's name which starts with the letter \"R\"";
Debug.ShouldStop(256);
if (_nm.Name.startsWith("H")) { 
 BA.debugLineNum = 106;BA.debugLine="Log(\"Connecting.....\")";
Debug.ShouldStop(512);
anywheresoftware.b4a.keywords.Common.Log("Connecting.....");
 BA.debugLineNum = 107;BA.debugLine="serial2.ConnectInsecure(admin, nm.Mac, 1)       'Also try using ConnectInsecure, is a better way to connect since there are devices that have some issues when trying to connect with Connect, or Connect2 or Connect3";
Debug.ShouldStop(1024);
_serial2.ConnectInsecure(processBA,_admin,_nm.Mac,(int)(1));
 BA.debugLineNum = 108;BA.debugLine="Exit";
Debug.ShouldStop(2048);
if (true) break;
 };
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 115;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _admin_statechanged(int _newstate,int _oldstate) throws Exception{
		Debug.PushSubsStack("Admin_StateChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("NewState", _newstate);
Debug.locals.put("OldState", _oldstate);
 BA.debugLineNum = 56;BA.debugLine="Sub Admin_StateChanged (NewState As Int, OldState As Int)";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 57;BA.debugLine="btnSearchForDevices.Enabled = (NewState = admin.STATE_ON)";
Debug.ShouldStop(16777216);
mostCurrent._btnsearchfordevices.setEnabled((_newstate==_admin.STATE_ON));
 BA.debugLineNum = 58;BA.debugLine="btnAllowConnection.Enabled = btnSearchForDevices.Enabled";
Debug.ShouldStop(33554432);
mostCurrent._btnallowconnection.setEnabled(mostCurrent._btnsearchfordevices.getEnabled());
 BA.debugLineNum = 59;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnsearchfordevices_click() throws Exception{
		Debug.PushSubsStack("btnSearchForDevices_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 67;BA.debugLine="Sub btnSearchForDevices_Click";
Debug.ShouldStop(4);
 BA.debugLineNum = 68;BA.debugLine="foundDevices.Initialize";
Debug.ShouldStop(8);
_founddevices.Initialize();
 BA.debugLineNum = 69;BA.debugLine="If admin.StartDiscovery	= False Then";
Debug.ShouldStop(16);
if (_admin.StartDiscovery()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 70;BA.debugLine="ToastMessageShow(\"Error starting discovery process.\", True)";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error starting discovery process.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 72;BA.debugLine="ProgressDialogShow(\"Searching for devices...\")";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.ProgressDialogShow(mostCurrent.activityBA,"Searching for devices...");
 };
 BA.debugLineNum = 74;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 12120, new int[] {5, 3}, "1a5257e4-ab93-42e1-96b3-9c76bc80a591");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
chatactivity._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (chatactivity.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}


            if (chatactivity.previousOne != null) {
				Activity a = chatactivity.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim btnSearchForDevices As Button";
mostCurrent._btnsearchfordevices = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 25;BA.debugLine="Dim btnAllowConnection As Button";
mostCurrent._btnallowconnection = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 13;BA.debugLine="Dim admin As BluetoothAdmin";
_admin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 15;BA.debugLine="Dim serial1 As Serial";
_serial1 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 16;BA.debugLine="Dim serial2 As Serial";
_serial2 = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 17;BA.debugLine="Dim foundDevices As List";
_founddevices = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 19;BA.debugLine="Type NameAndMac (Name As String, Mac As String)";
;
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
public static String  _serial1_connected(boolean _success) throws Exception{
		Debug.PushSubsStack("Serial1_Connected (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Success", _success);
 BA.debugLineNum = 126;BA.debugLine="Sub Serial1_Connected (Success As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 127;BA.debugLine="ProgressDialogHide";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 BA.debugLineNum = 128;BA.debugLine="Log(\"connected: \" & Success)";
Debug.ShouldStop(-2147483648);
anywheresoftware.b4a.keywords.Common.Log("connected: "+String.valueOf(_success));
 BA.debugLineNum = 129;BA.debugLine="If Success = False Then";
Debug.ShouldStop(1);
if (_success==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 130;BA.debugLine="Log(LastException.Message)";
Debug.ShouldStop(2);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage());
 BA.debugLineNum = 131;BA.debugLine="ToastMessageShow(\"Error connecting serial 1: \" & LastException.Message, True)";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error connecting serial 1: "+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
 }else {
 BA.debugLineNum = 133;BA.debugLine="StartActivity(ChatActivity)";
Debug.ShouldStop(16);
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._chatactivity.getObject()));
 };
 BA.debugLineNum = 135;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"admin",_admin,"serial1",_serial1,"serial2",_serial2,"foundDevices",_founddevices,"btnSearchForDevices",_btnsearchfordevices,"btnAllowConnection",_btnallowconnection,"ChatActivity",Debug.moduleToString(anywheresoftware.b4a.samples.bluetooth.chatactivity.class)};
}
}
